#! /usr/bin/env node
'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _cosmiconfig = require('cosmiconfig');

var _cosmiconfig2 = _interopRequireDefault(_cosmiconfig);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isTruthy = function isTruthy(value) {
  return Boolean(value && !['false', '0', 'off', 'no'].includes(value.toLowerCase()));
};

var run = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    var _process$argv, argv, args, configPath, preview, overwrite, tags, config;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _process$argv = (0, _toArray3.default)(process.argv), argv = _process$argv.slice(2);
            args = (0, _minimist2.default)(argv);
            configPath = args.config ? _path2.default.resolve(args.config) : null;
            preview = isTruthy(args.preview);
            overwrite = isTruthy(args.overwrite);
            tags = args._;

            if (!(tags.length === 0)) {
              _context3.next = 8;
              break;
            }

            throw new Error('No tags provided');

          case 8:
            _context3.next = 10;
            return (0, _cosmiconfig2.default)('github-release', {
              transform: function () {
                var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref2) {
                  var _config = _ref2.config,
                      filePath = _ref2.filePath;
                  var templatePath;
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          templatePath = _config.templatePath;

                          if (typeof templatePath === 'string' && !_path2.default.isAbsolute(templatePath)) {
                            templatePath = _path2.default.resolve(_path2.default.dirname(filePath), templatePath);
                          }
                          return _context.abrupt('return', (0, _extends3.default)({}, _config, {
                            templatePath
                          }));

                        case 3:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined);
                }));

                function transform(_x) {
                  return _ref3.apply(this, arguments);
                }

                return transform;
              }()
            }).load('./', configPath);

          case 10:
            config = _context3.sent;

            if (config) {
              _context3.next = 13;
              break;
            }

            throw new Error('No config file found. Create a github-release.config.js file or specify the path to the config file using the --config option');

          case 13:
            _context3.next = 15;
            return _promise2.default.all(tags.map(function () {
              var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(tag) {
                var result;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        _context2.next = 3;
                        return (0, _index2.default)((0, _extends3.default)({}, config, {
                          preview,
                          overwrite: overwrite || config.overwrite,
                          tag
                        }));

                      case 3:
                        result = _context2.sent;

                        console.log(preview ? result : `Release ${tag} published at ${result}`);
                        _context2.next = 14;
                        break;

                      case 7:
                        _context2.prev = 7;
                        _context2.t0 = _context2['catch'](0);

                        if (!(_context2.t0 === _index.NO_PREVIOUS_RELEASE)) {
                          _context2.next = 13;
                          break;
                        }

                        process.emitWarning(_context2.t0);
                        _context2.next = 14;
                        break;

                      case 13:
                        throw _context2.t0;

                      case 14:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, undefined, [[0, 7]]);
              }));

              return function (_x2) {
                return _ref4.apply(this, arguments);
              };
            }()));

          case 15:
            return _context3.abrupt('return', _context3.sent);

          case 16:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function run() {
    return _ref.apply(this, arguments);
  };
}();

run().catch(function (err) {
  console.error(err);
  process.exit(1);
});
//# sourceMappingURL=cli.js.map