'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _lodash = require('lodash.foreach');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.isobject');

var _lodash6 = _interopRequireDefault(_lodash5);

var _github = require('github');

var _github2 = _interopRequireDefault(_github);

var _mustache = require('mustache');

var _mustache2 = _interopRequireDefault(_mustache);

var _semverSort = require('semver-sort');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var readFile = (0, _es6Promisify2.default)(_fs.readFile);
var templateCache = {};

var DEFAULT_TEMPLATE = _path2.default.resolve(__dirname, 'defaultTemplate.md.hbs');
var NO_PREVIOUS_RELEASE = new Error('No previous release found');

var createGitHubRelease = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(config) {
    var authenticateOptions, owner, repo, tag, _config$template, templatePath, _config$templateProps, templateProps, _config$showDiff, showDiff, _config$apiOptions, apiOptions, _config$preview, preview, _config$overwrite, overwrite, render, fetchingTemplate, template, gitHub, _ref4, newTag, previousTag, _ref5, compareUrl, commits, files, pullRequests, body;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if ((0, _lodash6.default)(config)) {
              _context3.next = 2;
              break;
            }

            throw new Error('config must be an object');

          case 2:
            ;['authenticateOptions', 'owner', 'repo', 'tag'].forEach(function (property) {
              if (!config[property]) {
                throw new Error(`${property} property is required`);
              }
            });
            (0, _lodash2.default)({
              authenticateOptions: 'object',
              owner: 'string',
              repo: 'string',
              tag: 'string',
              render: 'function',
              template: 'string',
              templateProps: 'object',
              showDiff: 'function',
              apiOptions: 'object',
              preview: 'boolean',
              overwrite: 'boolean'
            }, function (type, property) {
              var value = config[property];
              if (value !== undefined && (type === 'object' ? !(0, _lodash6.default)(value) : typeof value !== type)) {
                throw new Error(`${property} property must be of type ${type}`);
              }
            });

            if (!(config.template && config.render)) {
              _context3.next = 7;
              break;
            }

            throw new Error('template and render properties are exclusive');

          case 7:
            authenticateOptions = config.authenticateOptions, owner = config.owner, repo = config.repo, tag = config.tag, _config$template = config.template, templatePath = _config$template === undefined ? DEFAULT_TEMPLATE : _config$template, _config$templateProps = config.templateProps, templateProps = _config$templateProps === undefined ? {} : _config$templateProps, _config$showDiff = config.showDiff, showDiff = _config$showDiff === undefined ? function () {
              return true;
            } : _config$showDiff, _config$apiOptions = config.apiOptions, apiOptions = _config$apiOptions === undefined ? {} : _config$apiOptions, _config$preview = config.preview, preview = _config$preview === undefined ? false : _config$preview, _config$overwrite = config.overwrite, overwrite = _config$overwrite === undefined ? false : _config$overwrite;
            render = void 0;

            if (!config.render) {
              _context3.next = 13;
              break;
            }

            render = function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(view) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return config.render(view);

                      case 2:
                        return _context.abrupt('return', _context.sent);

                      case 3:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              }));

              return function render(_x2) {
                return _ref2.apply(this, arguments);
              };
            }();
            _context3.next = 19;
            break;

          case 13:
            fetchingTemplate = templateCache[templatePath];

            if (!fetchingTemplate) {
              fetchingTemplate = readFile(templatePath, 'utf8');
              templateCache[templatePath] = fetchingTemplate;
            }
            _context3.next = 17;
            return fetchingTemplate;

          case 17:
            template = _context3.sent;

            render = function () {
              var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(view) {
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        return _context2.abrupt('return', _mustache2.default.render(template, view));

                      case 1:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, undefined);
              }));

              return function render(_x3) {
                return _ref3.apply(this, arguments);
              };
            }();

          case 19:
            gitHub = new _github2.default(apiOptions);

            gitHub.authenticate(authenticateOptions);

            _context3.next = 23;
            return fetchTags(gitHub, { owner, repo, tag });

          case 23:
            _ref4 = _context3.sent;
            newTag = _ref4.newTag;
            previousTag = _ref4.previousTag;
            _context3.next = 28;
            return fetchDiff(gitHub, {
              owner,
              repo,
              newTag,
              previousTag
            });

          case 28:
            _ref5 = _context3.sent;
            compareUrl = _ref5.compareUrl;
            commits = _ref5.commits;
            files = _ref5.files;
            _context3.next = 34;
            return fetchPullRequests(gitHub, { owner, repo, commits });

          case 34:
            pullRequests = _context3.sent;
            _context3.next = 37;
            return renderBody({
              owner,
              repo,
              showDiff,
              newTag,
              render,
              templateProps,
              previousTag,
              compareUrl,
              commits,
              files,
              pullRequests
            });

          case 37:
            body = _context3.sent;

            if (!preview) {
              _context3.next = 40;
              break;
            }

            return _context3.abrupt('return', body);

          case 40:
            _context3.next = 42;
            return createRelease(gitHub, { owner, repo, newTag, body, overwrite });

          case 42:
            return _context3.abrupt('return', _context3.sent);

          case 43:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function createGitHubRelease(_x) {
    return _ref.apply(this, arguments);
  };
}();

createGitHubRelease.DEFAULT_TEMPLATE = DEFAULT_TEMPLATE;
createGitHubRelease.NO_PREVIOUS_RELEASE = NO_PREVIOUS_RELEASE;

exports.default = createGitHubRelease;


var fetchTags = function () {
  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(gitHub, _ref6) {
    var owner = _ref6.owner,
        repo = _ref6.repo,
        tag = _ref6.tag;

    var _ref8, data, tags, newTagIndex;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return gitHub.gitdata.getTags({ owner, repo });

          case 2:
            _ref8 = _context4.sent;
            data = _ref8.data;
            tags = (0, _semverSort.asc)(data.map(function (_tag) {
              return _tag.ref.split('/').pop();
            }));
            newTagIndex = tags.findIndex(function (_tag) {
              return _tag === tag;
            });

            if (!(newTagIndex < 0)) {
              _context4.next = 10;
              break;
            }

            throw new Error(`Could not find tag ${tag}`);

          case 10:
            if (!(newTagIndex === 0)) {
              _context4.next = 12;
              break;
            }

            throw NO_PREVIOUS_RELEASE;

          case 12:
            return _context4.abrupt('return', {
              newTag: tags[newTagIndex],
              previousTag: tags[newTagIndex - 1]
            });

          case 13:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function fetchTags(_x4, _x5) {
    return _ref7.apply(this, arguments);
  };
}();

var fetchDiff = function () {
  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(gitHub, _ref9) {
    var owner = _ref9.owner,
        repo = _ref9.repo,
        newTag = _ref9.newTag,
        previousTag = _ref9.previousTag;

    var _ref11, data;

    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return gitHub.repos.compareCommits({
              owner,
              repo,
              base: previousTag,
              head: newTag
            });

          case 2:
            _ref11 = _context5.sent;
            data = _ref11.data;
            return _context5.abrupt('return', {
              compareUrl: data.html_url,
              commits: data.commits.map(function (commit) {
                return {
                  id: commit.sha.substr(0, 7),
                  url: commit.html_url,
                  author: {
                    name: commit.author.login,
                    url: commit.author.html_url,
                    avatar: commit.author.avatar_url
                  },
                  date: new Date(commit.commit.committer.date),
                  message: commit.commit.message
                };
              }),
              files: data.files.map(function (file) {
                return {
                  filename: file.filename,
                  url: file.blob_url,
                  status: file.status,
                  changes: file.changes,
                  lines: file.patch ? file.patch.split('\n').length : null,
                  diff: file.patch || null
                };
              })
            });

          case 5:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function fetchDiff(_x6, _x7) {
    return _ref10.apply(this, arguments);
  };
}();

var fetchPullRequests = function () {
  var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(gitHub, _ref12) {
    var owner = _ref12.owner,
        repo = _ref12.repo,
        commits = _ref12.commits;
    var numbers, pullRequests;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            numbers = commits.map(function (_ref14) {
              var message = _ref14.message;

              var match = message.match(/\(#([0-9]+)\)/);
              if (match) {
                var _match = (0, _slicedToArray3.default)(match, 2),
                    number = _match[1];

                return number;
              } else {
                return null;
              }
            }).filter(function (number) {
              return number;
            });
            _context7.next = 3;
            return _promise2.default.all(numbers.map(function () {
              var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(number) {
                var _ref16, _ref17, pullData, commentsData;

                return _regenerator2.default.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        _context6.prev = 0;
                        _context6.next = 3;
                        return _promise2.default.all([gitHub.pullRequests.get({
                          owner,
                          repo,
                          number
                        }), gitHub.issues.getComments({
                          owner,
                          repo,
                          number
                        })]);

                      case 3:
                        _ref16 = _context6.sent;
                        _ref17 = (0, _slicedToArray3.default)(_ref16, 2);
                        pullData = _ref17[0].data;
                        commentsData = _ref17[1].data;
                        return _context6.abrupt('return', pullData.merged ? {
                          url: pullData.html_url,
                          number: pullData.number,
                          title: pullData.title,
                          body: pullData.body,
                          comments: commentsData.map(function (comment) {
                            return {
                              url: comment.html_url,
                              body: comment.body,
                              author: {
                                name: comment.user.login,
                                url: comment.user.html_url,
                                avatar: comment.user.avatar_url
                              },
                              date: new Date(comment.created_at)
                            };
                          }),
                          author: {
                            name: pullData.user.login,
                            url: pullData.user.html_url,
                            avatar: pullData.user.avatar_url
                          },
                          date: new Date(pullData.merged_at)
                        } : null);

                      case 10:
                        _context6.prev = 10;
                        _context6.t0 = _context6['catch'](0);

                        if (!(_context6.t0.code === 404)) {
                          _context6.next = 16;
                          break;
                        }

                        return _context6.abrupt('return', null);

                      case 16:
                        throw _context6.t0;

                      case 17:
                      case 'end':
                        return _context6.stop();
                    }
                  }
                }, _callee6, undefined, [[0, 10]]);
              }));

              return function (_x10) {
                return _ref15.apply(this, arguments);
              };
            }()));

          case 3:
            pullRequests = _context7.sent;
            return _context7.abrupt('return', pullRequests.filter(function (pullRequest) {
              return pullRequest;
            }));

          case 5:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function fetchPullRequests(_x8, _x9) {
    return _ref13.apply(this, arguments);
  };
}();

var renderBody = function () {
  var _ref19 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(_ref18) {
    var owner = _ref18.owner,
        repo = _ref18.repo,
        render = _ref18.render,
        templateProps = _ref18.templateProps,
        showDiff = _ref18.showDiff,
        newTag = _ref18.newTag,
        previousTag = _ref18.previousTag,
        compareUrl = _ref18.compareUrl,
        commits = _ref18.commits,
        files = _ref18.files,
        pullRequests = _ref18.pullRequests;
    var avatar;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.t0 = render;
            _context8.t1 = _extends3.default;
            _context8.t2 = compareUrl;
            _context8.t3 = {
              name: newTag,
              url: `https://github.com/${owner}/${repo}/tree/${newTag}`
            };
            _context8.t4 = {
              name: previousTag,
              url: `https://github.com/${owner}/${repo}/tree/${previousTag}`
            };
            _context8.t5 = commits.map(function (commit) {
              return (0, _extends3.default)({}, commit, {
                message: commit.message.replace(/[\r\n]+/g, '<br>')
              });
            });
            _context8.t6 = files.map(function (file) {
              return (0, _extends3.default)({}, file, {
                diff: file.diff && showDiff(file) && file.diff.replace(/```/g, '​```')
              });
            });
            _context8.t7 = pullRequests;
            _context8.t8 = {
              compareUrl: _context8.t2,
              newTag: _context8.t3,
              previousTag: _context8.t4,
              commits: _context8.t5,
              files: _context8.t6,
              pullRequests: _context8.t7,

              icon() {
                return {
                  added: ':heavy_plus_sign:',
                  modified: '',
                  removed: ':heavy_minus_sign:'
                }[this.status];
              },
              formattedDate() {
                return this.date.toLocaleDateString(undefined, { timeZone: 'UTC' });
              },
              avatarUrl() {
                avatar = this.author.avatar;

                return `${avatar}${avatar.includes('?') ? '&' : '?'}size=20`;
              }
            };
            _context8.t9 = templateProps;
            _context8.t10 = (0, _context8.t1)(_context8.t8, _context8.t9);
            _context8.next = 13;
            return (0, _context8.t0)(_context8.t10);

          case 13:
            return _context8.abrupt('return', _context8.sent);

          case 14:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function renderBody(_x11) {
    return _ref19.apply(this, arguments);
  };
}();

var createRelease = function () {
  var _ref21 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(gitHub, _ref20) {
    var owner = _ref20.owner,
        repo = _ref20.repo,
        newTag = _ref20.newTag,
        body = _ref20.body,
        overwrite = _ref20.overwrite;

    var _ref22, data, message, _ref23, existingRelease, _ref24, _data;

    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.prev = 0;
            _context9.next = 3;
            return gitHub.repos.createRelease({
              owner,
              repo,
              tag_name: newTag,
              name: newTag,
              body
            });

          case 3:
            _ref22 = _context9.sent;
            data = _ref22.data;
            return _context9.abrupt('return', data.html_url);

          case 8:
            _context9.prev = 8;
            _context9.t0 = _context9['catch'](0);

            if (overwrite) {
              _context9.next = 12;
              break;
            }

            throw _context9.t0;

          case 12:
            message = void 0;
            _context9.prev = 13;

            message = JSON.parse(_context9.t0.message);
            _context9.next = 20;
            break;

          case 17:
            _context9.prev = 17;
            _context9.t1 = _context9['catch'](13);
            throw _context9.t0;

          case 20:
            if (!((0, _lodash4.default)(message, 'errors[0].code') === 'already_exists')) {
              _context9.next = 32;
              break;
            }

            _context9.next = 23;
            return gitHub.repos.getReleaseByTag({
              owner,
              repo,
              tag: newTag
            });

          case 23:
            _ref23 = _context9.sent;
            existingRelease = _ref23.data;
            _context9.next = 27;
            return gitHub.repos.editRelease({
              id: existingRelease.id,
              owner,
              repo,
              tag_name: newTag,
              name: newTag,
              body
            });

          case 27:
            _ref24 = _context9.sent;
            _data = _ref24.data;
            return _context9.abrupt('return', _data.html_url);

          case 32:
            throw _context9.t0;

          case 33:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, undefined, [[0, 8], [13, 17]]);
  }));

  return function createRelease(_x12, _x13) {
    return _ref21.apply(this, arguments);
  };
}();
module.exports = exports['default'];
//# sourceMappingURL=index.js.map